<template>
  <q-list separator>
    <q-item v-for="(person, phoneNumber) in participants" :key="phoneNumber" class="q-px-none"
      :clickable="phoneNumber !== usersPhone" @click="handleDeletePerson(phoneNumber)">
      <q-item-section avatar top>
        <div style="min-width: 140px">
          <q-item-label>
            {{ participantName(phoneNumber) }}
            <q-icon v-if="person.Moderator" color="orange" name="star"
              style="margin-right:5px; padding-bottom:2px; font-size: 0.9em;" />
          </q-item-label>
          <q-item-label caption>{{ phoneNumber }}</q-item-label>
        </div>
      </q-item-section>

      <q-item-section>
        <q-item-label>
          <div class="trunk-warning">
            {{ getTrunkWarning() }}
          </div>
        </q-item-label>
      </q-item-section>

      <q-item-section side>
        <div display="flex">
          <q-checkbox :label="$t('moderator')" left-label :disable="isUser(phoneNumber)" :value="person.Moderator"
            @input="handleToggleModerator(phoneNumber)" />
          <q-btn :disable="isUser(phoneNumber)" icon="delete" flat round dense
            @click.stop="handleDeletePerson(phoneNumber)" />
        </div>
      </q-item-section>
    </q-item>
  </q-list>
</template>
<script>

import { parseNumber } from "../utils/phone"

// This component is for managing the participants of an UPCOMING conference only
export default {
  props: {
    participants: {
      required: true,
    },
    requestToggleModerator: {
      required: true,
      // (phoneNumber: string) => void
    },
    requestDelete: {
      required: true,
      // (phoneNumber: string) => void
    },
    usersPhone: {
      // This is the phone number of the currently logged in user
      required: true,
      type: String,
    },
    trunk: {
      required: true
    }
  },
  methods: {
    getTrunkWarning()
    {
      if (!this.trunk || this.trunk.handle_all_countries) return null;

      let parsed = parseNumber(this.trunk.caller_number);
      if (!this.trunk.codes_cost_per_min['+' + parsed.countryCallingCode])
      {
        return this.$t("schedule_session.section_3.trunk_warning");
      }
    },
    participantName(phoneNumber)
    {
      if (phoneNumber == this.usersPhone)
      {
        return "You";
      }
      return this.participants[phoneNumber].Name;
    },
    isUser(phoneNumber)
    {
      return phoneNumber === this.usersPhone;
    },
    handleDeletePerson(phoneNumber)
    {
      this.requestDelete(phoneNumber);
    },
    handleToggleModerator(phoneNumber)
    {
      this.requestToggleModerator(phoneNumber);
    }
  },
};
</script>
<style scoped>
.trunk-warning {
  font-size: small;
  color: red;
}
</style>